#<profile4xi profile = "31"/>
#<program4xi program = "walk2parse4app.py">
#<abstract4xi abstract = "walks through HTML files of spefied directory and its subdirectories parsing html files as required"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "check and edit version4xi.py, if necessary"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'walk2parse4app' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi      # from lutiprocessing4xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2debug

global count2line
global count2file

global kb2file
global kb2search
global kb2stat
global kb2linestat
global kb2tag
global kb2linetag

global key2file                        
global key2search
global key2stat
global key2tag
global key2linetag
global key2tagend
global key2tagmin
global key2tagmax  

global keys2file
global keys2search
global keys2stat
global keys2linestat 
global keys2tag
global keys2linetag
global keys2tagend
global keys2tagstart   

global name2create

global path2input
global path2temp4source  
global path2read4xi                          # path for input source targets
global PickleKB4Xi
global profile2fetch                         # extension for files

global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False    # turn on/off 

count2line = 0
count2file = 0

kb2file       = {}
kb2search     = {}
kb2stat       = {}
kb2linestat   = {}
kb2tag        = {}
kb2linetag    = {}
kb2tagend     = {}
kb2tagstart   = {}

key2tagend = 3
key2tagmin = 1
key2tagmax = 2  

# =========================================================================================
# KB2TAG            MIN   MAX   END           
# =========================================================================================
kb2tag      = {
'<!doctype html>': {1: 1, 2: 1,    3: None},
'<html>'         : {1: 1, 2: 1,    3: '</html>'},
'<body>'         : {1: 1, 2: 1,    3: '</body>'},
'<table>'        : {1: 1, 2: 1,    3: '</table>'},
'<head>'         : {1: 1, 2: 1,    3: '</head>'},
'<link'          : {1: 1, 2: 9999, 3: None},
'<meta'          : {1: 1, 2: 1,    3: None},
'<title>'        : {1: 1, 2: 1,    3: '</title>'},
'<style'         : {1: 1, 2: 1,    3: '</style>'},
'<tbody>'        : {1: 1, 2: 1,    3: '</tbody>'},
'<tr>'           : {1: 1, 2: 9999, 3: '</tr>'},
'<td>'           : {1: 1, 2: 9999, 3: '</td>'},
'<a'             : {1: 1, 2: 9999, 3: '</a>'},
'<div'           : {1: 1, 2: 9999, 3: '</div>'},
'<b>'            : {1: 1, 2: 9999, 3: '</b>'},
'<h3>'           : {1: 1, 2: 9999, 3: '</h3>'},
'<h2>'           : {1: 1, 2: 9999, 3: '</h2>'}
}

# =========================================================================================
# KB2LINETAG        MIN   MAX          END           
# =========================================================================================
kb2linetag      = {
'<a'             : {1: 1, 2: 9999, 3: '</a>'},
'<div'           : {1: 1, 2: 9999, 3: '</div>'},
'<b>'            : {1: 1, 2: 9999, 3: '</b>'},
'<h3>'           : {1: 1, 2: 9999, 3: '</h3>'},
'<h2>'           : {1: 1, 2: 9999, 3: '</h2>'}
}

# ==============================================================================================
# KB2SEARCH  
# ==============================================================================================
kb2search [1]='<!doctype html>'
kb2search [2]='<html>'
kb2search [3]='<body>'
kb2search [4]='<table>'
kb2search [5]='<head>'
kb2search [6]='<link'
kb2search [7]='<meta'
kb2search [8]='<title>'
kb2search [9]='<style'

kb2search [10]='<tbody>'
kb2search [11]='<tr>'
kb2search [12]='<td>'
kb2search [13]='<a'
kb2search [14]='<div'

kb2search [15]='</html>'
kb2search [16]='</body>'
kb2search [17]='</table>'
kb2search [18]='</head>'
kb2search [19]='</title>'
kb2search [20]='</style>'

kb2search [21]='</tbody>'
kb2search [22]='</tr>'
kb2search [23]='</td>'
kb2search [24]='</a>'
kb2search [25]='</div>'

kb2search [26]='<h3>'
kb2search [27]='</h3>'

kb2search [28]='<b>'
kb2search [29]='</b>'

kb2search [30]='<h2>'
kb2search [31]='</h2>'


# -------------------------------------------------------------------------------------------------
# KEYS
# -------------------------------------------------------------------------------------------------
keys2file     = kb2file.keys()
keys2search   = kb2search.keys()
keys2stat     = kb2stat.keys()
keys2linestat = kb2linestat.keys()
keys2tag      = kb2tag.keys()
keys2linetag  = kb2linetag.keys()

    
# -------------------------------------------------------------------------------------------------
# PATHS
# -------------------------------------------------------------------------------------------------
path2read4xi  = VersionKB4Xi['input2parse4app']   # defines input folder to be walked with all its subfolders
    
# -------------------------------------------------------------------------------------------------
#
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = '.html'                      # object types to be fetched
                                             # '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C, 
                                             # '.html', 'xml'

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4replace" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 1A/33) OF SET2TRACE4REPLACE - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 1B/33) OF SET2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4REPLACE - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # APU2Buffer4Xi; APU2CommandQueue4Xi ... finish2commandqueue4bpu; finish2commandqueue4apu ...
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    if ack2debug is True:
        print('=' *33)
        print("(Step 33/33) OF SET2TRACE4REPLACE - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4replace" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 01A/33) of DENY2TRACE4REPLACE: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 01B/33) OF DENY2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4REPLACE - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4REPLACE - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4REPLACE - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4REPLACE - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4REPLACE *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4REPLACE - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4REPLACE - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    if ack2debug is True:
        print("(Step 033/33) OF SET2TRACE4REPLACE - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global ack2debug
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    if ack2debug is True:
        print("(Step 001A/33) OF TAILOR2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # 'Pipe4Xi': 'NACK4TRACE',
         # 'Queue4Xi': 'NACK4TRACE',         
         # 'Process4Xi': 'NACK4TRACE',
         # 'walk2parse4app': 'NACK4TRACE' # turns on/off
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        if ack2debug is True:
            print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
            # Pipe4Xi, Process4Xi, Queue4Xi, walk2parse4app

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    if ack2debug is True:
        print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
        #

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
    
    class2print  = "walk2parse4app"
    method2print = "walk2parse4app" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-walk2parse4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2parse4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2parse4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing ofStudio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="yourDragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing walk2parse4app.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">walk2parse4app sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-walk2parse4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2parse4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2parse4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for walk2parse4app.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-walk2parse4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2parse4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2parse4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for walk2parse4app.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of walk2parse4app.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "zerostat" usage = "
# zero tag statistics before processing each html file
#"> 
# -------------------------------------------------------------------------------------------------    
def zerostat():
    global count2file
    global kb2file
    global kb2stat
    global kb2linestat
    global keys2stat
    global path2input    
    
    count2file = count2file + 1   
    
    kb2file [count2file] = path2input
    
    kb2stat [count2file] = {} 
          
    kb2stat [count2file] ['<!doctype html>'] = 0
    
    kb2stat [count2file] ['<html>']  = 0
    kb2stat [count2file] ['</html>']  = 0
    
    kb2stat [count2file] ['<body>']  = 0
    kb2stat [count2file] ['</body>']  = 0
    
    kb2stat [count2file] ['<table>'] = 0
    kb2stat [count2file] ['</table>'] = 0
    
    kb2stat [count2file] ['<head>']  = 0
    kb2stat [count2file] ['</head>']  = 0
    
    kb2stat [count2file] ['<link']  = 0
    
    kb2stat [count2file] ['<meta']   = 0
    
    kb2stat [count2file] ['<title>'] = 0
    kb2stat [count2file] ['</title>'] = 0
    
    kb2stat [count2file] ['<style'] = 0
    kb2stat [count2file] ['</style>'] = 0
    
    kb2stat [count2file] ['<tbody>'] = 0
    kb2stat [count2file] ['</tbody>'] = 0
    
    kb2stat [count2file] ['<tr>']    = 0
    kb2stat [count2file] ['</tr>']    = 0
    
    kb2stat [count2file] ['<td>']    = 0
    kb2stat [count2file] ['</td>']    = 0
    
    kb2stat [count2file] ['<a']      = 0
    kb2stat [count2file] ['</a>']     = 0
    
    kb2stat [count2file] ['<div']    = 0
    kb2stat [count2file] ['</div>']   = 0
    
 
    kb2stat [count2file] ['<h3>']     = 0
    kb2stat [count2file] ['</h3>']    = 0
    
    kb2stat [count2file] ['<h2>']     = 0
    kb2stat [count2file] ['</h2>']    = 0
    
    kb2stat [count2file] ['<b>']      = 0
    kb2stat [count2file] ['</b>']     = 0
    

    # -------------------------------------------------------------------------------------------------
    # end of zerostat                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "zerolinestat" usage = "
# zero tag statistics per line before processing the line
#"> 
# -------------------------------------------------------------------------------------------------    
def zerolinestat():
    global kb2linestat
    global keys2linestat
  
    kb2linestat = {} 
          
    kb2linestat ['<td>']    = 0
    kb2linestat ['</td>']    = 0
    
    kb2linestat ['<a']      = 0
    kb2linestat ['</a>']     = 0
    
    kb2linestat ['<div']    = 0
    kb2linestat ['</div>']   = 0

    kb2linestat ['<h3>']     = 0
    kb2linestat ['</h3>']    = 0
    
    kb2linestat ['<h2>']     = 0
    kb2linestat ['</h2>']    = 0
    
    kb2linestat ['<b>']      = 0
    kb2linestat ['</b>']     = 0
    
    keys2linestat = kb2linestat.keys()
    
        
    # -------------------------------------------------------------------------------------------------
    # end of zerolinestat                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>


     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "walk2parse4app" usage = "
#   replaces defined targets from dragon4xi folders
#"> 
# -------------------------------------------------------------------------------------------------
def walk2parse4app(target2explore):
    global ack2debug

    global count2line
    global count2file
    
    global kb2file
    global kb2search
    global kb2stat
    global kb2linestat
    global kb2tag
    global kb2linetag                             

    global key2file
    global key2search
    global key2stat
    global key2linestat
    global key2tag
    global key2linetag 

    global keys2file
    global keys2search
    global keys2stat
    global keys2linestat
    global keys2tag
    global keys2linetag  
     
    global name2create   
    global path2input
    global path2read4xi                            # path for input source targets
    global profile2fetch                           # extension for files

    global t2xi
    global trace_object_count    
    
    class2print  = "walk2parse4app"
    method2print = "walk2parse4app" 
 
    # message2print = "{(Step 0A/33) using" + "; t2xi-using-by-walk2parse4app: " + str(t2xi)  + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    message2print = "{(Step 1/8) got" + "; target2explore-got-by-walk2parse4app: " + str(target2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # 
    
                  
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore)
    
    path2input = None    
    if name2target[1] == profile2fetch:
        # html
        count2line = 0
         
                 
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF WALK2PARSE4APP - TARGET ACCORDING TO PROFILE
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; target2explore-analyzing-by-walk2parse4app: " + str(target2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # G://temp//job2studio4xi//in//html//platform2com4yo.html
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF WALK2PARSE4APP - INPUT FILE PATH 
        # -----------------------------------------------------------------------------------------
        path2input = name2target[0] + profile2fetch 
        message2print = "{(Step 2A/33) set" + "; path2input-set-by-walk2parse4app to: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # G://temp//job2studio4xi//in//html//platform2com4yo.html 

        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF WALK2PARSE4APP - OPEN INPUT FILE
        # -----------------------------------------------------------------------------------------
        file2input = open(path2input,'r')
        message2print = "{(Step 3A/33) opened" + "; file2input-opened-by-walk2parse4app: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # <_io.TextIOWrapper name='G://temp//job2studio4xi//in//html//platform2com4yo.html' mode='r' encoding='cp1252'>
        zerostat() 
                
        while 1:
            # -------------------------------------------------------------------------------------
            # (Step 5/33) OF WALK2PARSE4APP - PROCESS FILE
            # -------------------------------------------------------------------------------------             
            line2process = file2input.readline()  
            if not line2process:
                # ---------------------------------------------------------------------------------
                # (Step 5/33) OF WALK2PARSE4APP - ALL LINES READ, FINISH
                # ---------------------------------------------------------------------------------             
                break                                               
            else:
                count2line = count2line + 1
                
                line2write = line2process
                first2tell = True
                ack2replace = False
                
                # ---------------------------------------------------------------------------------
                # (Step 7/33) OF WALK2PARSE4APP - PROCESS LINE - WRITE IS NOT DONE
                # ---------------------------------------------------------------------------------
                for key2search in keys2search:
                    # -----------------------------------------------------------------------------
                    # check all strings
                    # ----------------------------------------------------------------------------- 
                    string2search = kb2search[key2search]
                    len2search = len(string2search)
                    
                    string2update = "XX"
                    len2update = len(string2update)
                    
                    difference2len = len2update - len2search
                        
                    index2replace = str.find(line2write,string2search)
                    if (index2replace == -1):
                        pass

                    else:
                        ack2replace = True
                        if first2tell is True: 
                            message2print = "{(Step 7A/33) got" + "; line2process-got-by-walk2replace4app: " + str(line2process) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # <a id="000"><h2>Platform @yourDragon<b>&Xi;</b>.org <b>&Delta;</b> 19th of February 2020 <b>&Omega;</b> 8:17 AM</h2></a>
                            
                            first2tell = False
                              
                        message2print = "{(Step 7B/33) got" + "; string2search-got-by-walk2replace4app: " + str(string2search) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        message2print = "{(Step 7C/33) got" + "; string2update-got-by-walk2replace4app: " + str(string2update) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        message2print = "{(Step 7D/33) set" + "; index2replace-set-by-walk2replace4app to: " + str(index2replace) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        message2print = "{(Step 7E/33) got" + "; begin2write-got-by-walk2replace4app: " + str(line2write[0:index2replace]) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        begin2write = line2write[0:index2replace] + string2update
                                                
                        message2print = "{(Step 7H/33) set" + "; begin2write-set-by-walk2replace4app to: " + str(begin2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        index2next = index2replace + len2search                      
                        message2print = "{(Step 7I/33) set" + "; index2next-set-by-walk2replace4app to: " + str(index2next) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        line2write = begin2write + line2write[index2next:]
                        
                        message2print = "{(Step 7K/33) set" + "; line2write-set-by-walk2replace4app to: " + str(line2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # XX id="000"><h2>Platform @yourDragon<b>&Xi;</b>.org <b>&Delta;</b> 19th of February 2020 <b>&Omega;</b> 8:17 AM</h2></a>
                        # ...
                        # XX id="000">XXPlatform @yourDragonXX&Xi;XX.org <b>&Delta;</b> 19th of February 2020 <b>&Omega;</b> 8:17 AMXXXX
 
            # ---------------------------------------------------------------------------------
            # (Step 8/33) OF WALK2PARSE4APP - ANALYSE LINE STATISTICS JATKA
            # --------------------------------------------------------------------------------- 
            if ack2debug:
                print("(Step 8A/33) ANALYSING LINE STATISTICS - INDEX2REPLACE: ", index2replace, " LINE2WRITE: ", line2write)
            for key2line in sorted (keys2linestat):
                if ack2debug:
                    print("kb2linestat[ ", key2line, "]:" , kb2linestat [key2line])
                    # 
                
                errors2line = 0
                for key2line in sorted (keys2linestat):
                    if key2line in keys2linetag:   
                        key2match = kb2linetag [key2line] [key2tagend]
                        if key2match is None:
                            pass
                        else:         
                            if kb2linestat [key2line] == kb2linestat [key2match]:        
                                pass
                            else:
                                print("(Step 8Z1/33) * warning kb2linestat[ ", key2line, "]:" , kb2linestat [key2line], " .NE. ", kb2linestat [key2match], " kb2linestat[ ", key2match, "]")    
                                # 
                                print("(Step 8Z2/33) * warning line2process: ", line2process)    
                                # 
                                print("(Step 8Z3/33) * warning line2write: ", line2write)    
                                #
                                 
            zerolinestat()
                        
                        
                                        
        # -----------------------------------------------------------------------------------------
        # (Step 31/33) OF WALK2PARSE4APP - CLOSE INPUT
        # -----------------------------------------------------------------------------------------            
        file2input.close()
        message2print = "{(Step 31A/33) closed" + "; file2input-closed-by-walk2parse4app: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        # 
            
                        
       
    else:
        pass
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2debug
    
    global count2line
     
    global kb2file   
    global kb2search
    global kb2stat
    global kb2tag
    
    global keys2file
    global keys2search
    global keys2stat
    global keys2tag
    
    global key2file
    global key2search
    global key2stat
    global key2tag
    global key2tagend
    global key2tagmin
    global key2tagmax
        
    global path2read4xi
    global profile2fetch

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    if ack2debug is True:
        print("(Step 0A/33) OF MAIN WALK2PARSE4APP - SET T2XI TO: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
    
    set2trace4replace()                                                                                               # trace all classes and functions in the system
    deny2trace4replace()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                                 # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()

        
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 0B/33) OF MAIN WALK2PARSE4APP - VERSION 4.4 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " STARTED ", time4xi())
    # VERSION 4.4 FOR  G://temp//job2studio4xi//out//one2ftp4app//  WITH PROFILE:  .html  STARTED  09:04:33 02/11/20 FLE Standard Time
    
    pipe2fetch = Pipe4Xi()
    if ack2debug is True:
        print("(Step 1A/33) OF MAIN WALK2PARSE4APP - PIPE2FETCH ", pipe2fetch)    
        # PIPE2FETCH  (<pipeconnection4xi.PipeConnection4Xi object at 0x0000000002F71AC8>, <pipeconnection4xi.PipeConnection4Xi object at 0x0000000002F71B70>)
    queue2fetch = Queue4Xi()
    if ack2debug is True:
        print("(Step 1B/33) OF MAIN WALK2PARSE4APP - QUEUE2FETCH ", queue2fetch)    
        # QUEUE2FETCH  <queue4xi.Queue4Xi object at 0x0000000002F719B0>
        print("(Step 1C/33) OF MAIN WALK2PARSE4APP - PATH2READ4XI ", path2read4xi) 
        # G://temp//job2studio4xi//out//one2ftp4app//

    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            print("(Step 2A/33) OF MAIN WALK2PARSE4APP - DIRECTORY: ", file2walk)
            # G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app
            # G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev
        if os.path.isfile(file2walk):
            walk2parse4app(file2walk)
            
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 3A/33) OF MAIN WALK2PARSE4APP - VERSION 4.4 - IN: ", path2read4xi, " - PROFILE: ", profile2fetch, " COMPLETED  ", time4xi())
    # VERSION 4.4 - IN:  G://temp//job2studio4xi//out//one2ftp4app//  - PROFILE:  .html  COMPLETED   09:04:34 02/11/20 FLE Standard Time 

    # ===========================================================================
    print('=' *75)
    print("(Step 4A/33) OF MAIN WALK2PARSE4APP - KB2TAG:  ")
  
    for key2tag in sorted(keys2tag):
        print("kb2tag[ ", key2tag, "]: ", kb2tag[key2tag])
        # kb2tag[  <!doctype html> ]:  {1: 1, 2: 1, 3: None}
        # kb2tag[  <a ]:  {1: 1, 2: 9999, 3: '</a>'}
        # kb2tag[  <b> ]:  {1: 1, 2: 9999, 3: '</b>'}
        # kb2tag[  <body> ]:  {1: 1, 2: 1, 3: '</body>'}
        # kb2tag[  <div ]:  {1: 1, 2: 9999, 3: '</div>'}
        # kb2tag[  <h3> ]:  {1: 1, 2: 9999, 3: '</h3>'}
        # kb2tag[  <head> ]:  {1: 1, 2: 1, 3: '</head>'}
        # kb2tag[  <html> ]:  {1: 1, 2: 1, 3: '</html>'}
        # kb2tag[  <link ]:  {1: 1, 2: 9999, 3: None}
        # kb2tag[  <meta ]:  {1: 1, 2: 1, 3: None}
        # kb2tag[  <style ]:  {1: 1, 2: 1, 3: '</style>'}
        # kb2tag[  <table> ]:  {1: 1, 2: 1, 3: '</table>'}
        # kb2tag[  <tbody> ]:  {1: 1, 2: 1, 3: '</tbody>'}
        # kb2tag[  <td> ]:  {1: 1, 2: 9999, 3: '</td>'}
        # kb2tag[  <title> ]:  {1: 1, 2: 1, 3: '</title>'}
        # kb2tag[  <tr> ]:  {1: 1, 2: 9999, 3: '</tr>'}
        
    # ===========================================================================
    print('=' *75)
    print("(Step 4B/33) OF MAIN WALK2PARSE4APP - KB2SEARCH:  ")
    for key2search in sorted(keys2search):
        print("kb2search[ ", key2search, "]: ", kb2search[key2search])
        # kb2search[  1 ]:  <!doctype html>
        # kb2search[  2 ]:  <html>
        # kb2search[  3 ]:  <body>
        # kb2search[  4 ]:  <table>
        # kb2search[  5 ]:  <head>
        # kb2search[  6 ]:  <link
        # kb2search[  7 ]:  <meta
        # kb2search[  8 ]:  <title>
        # kb2search[  9 ]:  <style
        # kb2search[  10 ]:  <tbody>
        # kb2search[  11 ]:  <tr>
        # kb2search[  12 ]:  <td>
        # kb2search[  13 ]:  <a
        # kb2search[  14 ]:  <div
        # kb2search[  15 ]:  </html>
        # kb2search[  16 ]:  </body>
        # kb2search[  17 ]:  </table>
        # kb2search[  18 ]:  </head>
        # kb2search[  19 ]:  </title>
        # kb2search[  20 ]:  </style>
        # kb2search[  21 ]:  </tbody>
        # kb2search[  22 ]:  </tr>
        # kb2search[  23 ]:  </td>
        # kb2search[  24 ]:  </a>
        # kb2search[  25 ]:  </div>
        # kb2search[  26 ]:  <h3>
        # kb2search[  27 ]:  <b>
        # kb2search[  28 ]:  </h3>
        # kb2search[  29 ]:  </b>
        
    # ===========================================================================
    print('=' *75)
    print("(Step 4C/33) OF MAIN WALK2PARSE4APP - FILES PROCESSED:  ") 
    for key2file in sorted(keys2file):
        print("kb2file[ ", key2file, "]:", kb2file [key2file])        
        # kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
        # kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
    
    # ===========================================================================
    print('=' *75)     
    print("(Step 4D/33) OF MAIN WALK2PARSE4APP - KB2STAT FOR EACH FILE:  ")            
    for key2file in sorted (keys2file):
        print('=' *75)
        print("kb2file[ ", key2file, "]:", kb2file [key2file])   
        # 1 G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
        kb2statistics = kb2stat [key2file]
        keys2statistics = kb2statistics.keys()
        for key2statistics in keys2statistics:
            print("kb2statistics[", key2statistics, "]: ", kb2statistics[key2statistics])
            # kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
            # kb2statistics[ <style ]:  1
            # kb2statistics[ </style> ]:  1
            # kb2statistics[ <table> ]:  1
            # kb2statistics[ </div> ]:  43
            # kb2statistics[ </html> ]:  1
            # kb2statistics[ <h3> ]:  17
            # kb2statistics[ <link ]:  1
            # kb2statistics[ <body> ]:  1
            # kb2statistics[ <title> ]:  1
            # kb2statistics[ <a ]:  439
            # kb2statistics[ <td> ]:  245
            # kb2statistics[ </tbody> ]:  1
            # kb2statistics[ </title> ]:  1
            # kb2statistics[ </table> ]:  1
            # kb2statistics[ <meta ]:  1
            # kb2statistics[ <html> ]:  1
            # kb2statistics[ </td> ]:  245
            # kb2statistics[ </b> ]:  690
            # kb2statistics[ <tr> ]:  245
            # kb2statistics[ <head> ]:  1
            # kb2statistics[ </a> ]:  439
            # kb2statistics[ <tbody> ]:  1
            # kb2statistics[ </head> ]:  1
            # kb2statistics[ </h3> ]:  17
            # kb2statistics[ </tr> ]:  245
            # kb2statistics[ <!doctype html> ]:  1
            # kb2statistics[ <b> ]:  690
            # kb2statistics[ <div ]:  43
            # kb2statistics[ </body> ]:  1
            # ===========================================================================
            # kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
            # kb2statistics[ <style ]:  1
            # kb2statistics[ </style> ]:  1
            # kb2statistics[ <table> ]:  1
            # kb2statistics[ </div> ]:  43
            # kb2statistics[ </html> ]:  1
            # kb2statistics[ <h3> ]:  17
            # kb2statistics[ <link ]:  1
            # kb2statistics[ <body> ]:  1
            # kb2statistics[ <title> ]:  1
            # kb2statistics[ <a ]:  439
            # kb2statistics[ <td> ]:  245
            # kb2statistics[ </tbody> ]:  1
            # kb2statistics[ </title> ]:  1
            # kb2statistics[ </table> ]:  1
            # kb2statistics[ <meta ]:  1
            # kb2statistics[ <html> ]:  1
            # kb2statistics[ </td> ]:  244
            # kb2statistics[ </b> ]:  690
            # kb2statistics[ <tr> ]:  245
            # kb2statistics[ <head> ]:  1
            # kb2statistics[ </a> ]:  439
            # kb2statistics[ <tbody> ]:  1
            # kb2statistics[ </head> ]:  1
            # kb2statistics[ </h3> ]:  17
            # kb2statistics[ </tr> ]:  245
            # kb2statistics[ <!doctype html> ]:  1
            # kb2statistics[ <b> ]:  690
            # kb2statistics[ <div ]:  43
            # kb2statistics[ </body> ]:  1
        
    # =========================================================================== 
    print('=' *75)
    print("(Step 4E/33) OF MAIN WALK2PARSE4APP - CHECKED ENOUGH TAGS FOR EACH FILE ")
    for key2file in sorted (keys2file):
        print('=' *75)
        print("kb2file[ ", key2file, "]:", kb2file [key2file])   
        kb2statistics = kb2stat [key2file]
        keys2statistics = kb2statistics.keys()
        for key2statistics in keys2statistics:
            if key2statistics in keys2tag:
                kb2value = kb2tag [key2statistics]
                if kb2statistics [key2statistics] >= kb2value [key2tagmin]:
                    print("kb2statistics[ ", key2statistics, "]:" , kb2statistics [key2statistics], " >= ", kb2value [key2tagmin])
                else:
                    print("* note kb2statistics[ ", key2statistics, "]:" , kb2statistics [key2statistics], " < ", kb2value [key2tagmin])
            else:
                pass 
            # kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
            # kb2statistics[  <h3> ]: 17  >=  1
            # kb2statistics[  <tbody> ]: 1  >=  1
            # kb2statistics[  <style ]: 1  >=  1
            # kb2statistics[  <a ]: 439  >=  1
            # kb2statistics[  <meta ]: 1  >=  1
            # kb2statistics[  <td> ]: 245  >=  1
            # kb2statistics[  <link ]: 1  >=  1
            # kb2statistics[  <tr> ]: 245  >=  1
            # kb2statistics[  <b> ]: 690  >=  1
            # kb2statistics[  <table> ]: 1  >=  1
            # kb2statistics[  <div ]: 43  >=  1
            # kb2statistics[  <title> ]: 1  >=  1
            # kb2statistics[  <head> ]: 1  >=  1
            # kb2statistics[  <!doctype html> ]: 1  >=  1
            # kb2statistics[  <html> ]: 1  >=  1
            # kb2statistics[  <body> ]: 1  >=  1
            # ===========================================================================
            # kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
            # kb2statistics[  <h3> ]: 17  >=  1
            # kb2statistics[  <tbody> ]: 1  >=  1
            # kb2statistics[  <style ]: 1  >=  1
            # kb2statistics[  <a ]: 439  >=  1
            # kb2statistics[  <meta ]: 1  >=  1
            # kb2statistics[  <td> ]: 245  >=  1
            # kb2statistics[  <link ]: 1  >=  1
            # kb2statistics[  <tr> ]: 245  >=  1
            # kb2statistics[  <b> ]: 690  >=  1
            # kb2statistics[  <table> ]: 1  >=  1
            # kb2statistics[  <div ]: 43  >=  1
            # kb2statistics[  <title> ]: 1  >=  1
            # kb2statistics[  <head> ]: 1  >=  1
            # kb2statistics[  <!doctype html> ]: 1  >=  1
            # kb2statistics[  <html> ]: 1  >=  1
            # kb2statistics[  <body> ]: 1  >=  1      
                
    # =========================================================================== 
    print('=' *75)
    print("(Step 4F/33) OF MAIN WALK2PARSE4APP - CHECKED THAT NOT EXCEEDED MAXIMUM FOR EACH FILE ")

    for key2file in sorted (keys2file):
        print('=' *75)
        print("kb2file[ ", key2file, "]:", kb2file [key2file])   
        kb2statistics = kb2stat [key2file]
        keys2statistics = kb2statistics.keys()
        for key2statistics in keys2statistics:
            if key2statistics in keys2tag:
                kb2value = kb2tag [key2statistics]
                if kb2statistics [key2statistics] <= kb2value [key2tagmax]:
                    print("kb2statistics[ ", key2statistics, "]:" , kb2statistics [key2statistics], " <= ", kb2value [key2tagmax])
                else:
                    print("** error kb2statistics[ ", key2statistics, "]:" , kb2statistics [key2statistics], " > ", kb2value [key2tagmax])
            else:
                pass 
            # kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
            # kb2statistics[  <h3> ]: 17  <=  9999
            # kb2statistics[  <tbody> ]: 1  <=  1
            # kb2statistics[  <style ]: 1  <=  1
            # kb2statistics[  <a ]: 439  <=  9999
            # kb2statistics[  <meta ]: 1  <=  1
            # kb2statistics[  <td> ]: 245  <=  9999
            # kb2statistics[  <link ]: 1  <=  9999
            # kb2statistics[  <tr> ]: 245  <=  9999
            # kb2statistics[  <b> ]: 690  <=  9999
            # kb2statistics[  <table> ]: 1  <=  1
            # kb2statistics[  <div ]: 43  <=  9999
            # kb2statistics[  <title> ]: 1  <=  1
            # kb2statistics[  <head> ]: 1  <=  1
            # kb2statistics[  <!doctype html> ]: 1  <=  1
            # kb2statistics[  <html> ]: 1  <=  1
            # kb2statistics[  <body> ]: 1  <=  1
            # ===========================================================================
            # kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
            # kb2statistics[  <h3> ]: 17  <=  9999
            # kb2statistics[  <tbody> ]: 1  <=  1
            # kb2statistics[  <style ]: 1  <=  1
            # kb2statistics[  <a ]: 439  <=  9999
            # kb2statistics[  <meta ]: 1  <=  1
            # kb2statistics[  <td> ]: 245  <=  9999
            # kb2statistics[  <link ]: 1  <=  9999
            # kb2statistics[  <tr> ]: 245  <=  9999
            # kb2statistics[  <b> ]: 690  <=  9999
            # kb2statistics[  <table> ]: 1  <=  1
            # kb2statistics[  <div ]: 43  <=  9999
            # kb2statistics[  <title> ]: 1  <=  1
            # kb2statistics[  <head> ]: 1  <=  1
            # kb2statistics[  <!doctype html> ]: 1  <=  1
            # kb2statistics[  <html> ]: 1  <=  1
            # kb2statistics[  <body> ]: 1  <=  1   
                  
    # ===========================================================================           
    print('=' *75)
    print("(Step 4G/33) OF MAIN WALK2PARSE4APP - CHECKED BALANCE FOR EACH FILE")
    total2errors = 0
    kb2total = {}
    keys2total = kb2total.keys()
    for key2file in sorted (keys2file):
        print('=' *75)
        print("(Step 4G1/33) kb2file[ ", key2file, "]:", kb2file [key2file])
        # kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
        # kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
        
        kb2statistics = kb2stat [key2file]
        if ack2debug is True:
            print("(Step 4G2/33) kb2statistics: ", kb2statistics)
            # {'</html>': 1, '</a>': 439, '</title>': 1, '</table>': 1, ...
            # 
        keys2statistics = kb2statistics.keys()
        if ack2debug is True:
            print("(Step 4G3/33) keys2statistics: ", keys2statistics)
            # dict_keys(['</html>', '</a>', '</title>', '</table>', 
            # 
        
        for key2statistics in sorted (keys2statistics):
            if ack2debug is True:
                print("(Step 4G5/33) key2statistics: ", key2statistics)
                # </tr>
                # <a
            
            if key2statistics in keys2tag:   
                key2match = kb2tag [key2statistics] [key2tagend]
                if ack2debug is True:
                    print("(Step 4G6/33) key2match: ", key2match)
                    # None
                    # </a>
                if key2match is None:
                    pass
                else:         
                    kb2match = kb2statistics [key2match]
                    if ack2debug is True:
                        print("(Step 4G7(/33) kb2match: ", kb2match)
                        # 439 
                   
                    if kb2statistics [key2statistics] == kb2statistics [key2match]:        
                        if ack2debug is True:
                            print("(Step 4G8/33) kb2statistics[ ", key2statistics, "]:" , kb2statistics [key2statistics], " == ", kb2statistics [key2match])
                            # kb2statistics[  <a ]: 439  ==  439
                    else:
                        print("(Step 4GZ1/33) kb2file[ ", key2file, "]:", kb2file [key2file])
                        # kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
                        
                        print("(Step 4GZ2/33) ** error kb2statistics[ ", key2statistics, "]:" , kb2statistics [key2statistics], " .NE. ", kb2statistics [key2match])
                        # ** error kb2statistics[  <td> ]: 245  .NE.  244
                        
                        total2errors = total2errors + 1
                        key2total= key2file
                        kb2total [key2total] = total2errors
    # ===========================================================================           
    print('=' *75)
    print("(Step 4H/33) OF MAIN WALK2PARSE4APP - ERROR SUMMARY (IF ANY, SEE * warning )")
    for key2total in keys2total:
        print("** kb2file[",key2total,"]: ",kb2file[key2total], " ** kb2total[",key2total, "]:", kb2total[key2total], "**")     
        # ** kb2file[ 2 ]:  G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html  ** kb2total[ 2 ]: 1 **
        # 
    
    # =========================================================================== 
    # Notes:
    # 1) take small slices from the file in G://temp//job2studio4xi//out//one2do4app
    # 2) put them one by one into G://temp//job2studio4xi//in//one2do4app 
    # when you have found the problem slices
    # 3) copy paste the file in G://temp//job2studio4xi//out//one2do4app into G://temp//job2studio4xi//in//one2do4app
    # 4) edit necessary changes to G://temp//job2studio4xi//out//one2do4app
    # 5) run walk2parse4app with G://temp//job2studio4xi//out//one2do4app//
    # when parsing passes ok with your own edit actions
    # 7) run the required walk2xxxxxxxxx4app.py with G://temp//job2studio4xi//in//one2do4app 
    # 8) walk2parse4app with G://temp//job2studio4xi//out//one2do4app//
    # if there are parsing errors then edit again walk2xxxxxxxxx4app.py and go to 8)  
    # when parsing passes ok with the Python program
    # 9) copy G://temp//job2studio4xi//out//all//one2do4app into G://temp//job2studio4xi//in//all//one2do4app
    # 10) run the required walk2xxxxxxxxx4app.py with G://temp//job2studio4xi//in//all//one2do4app
    # 11) run walk2parse4app with G://temp//job2studio4xi//in//all//one2do4app
    # 12) once parsing is ok ftp upload G://temp//job2studio4xi//out//all//one2do4app into server
    # once server is updated
    # 14) test  https://www.app2ace4yo.app/
    # see Recorded History at the end of this module
    # 15) validate with  https://html5.validator.nu/
    # - note: walk2parse4app.py is better !
                           
    # ===========================================================================           

                                                    
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    # print ('(Step 1E/33) OF MAIN WALK2PARSE4APP - PRINTING TRACE WITH T2XI', t2xi)
    # 
    # print_trace4xi(t2xi)        
    # print ('(Step 1F/33) OF MAIN WALK2PARSE4APP - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ======================================================================
# (Step 0B/33) OF MAIN WALK2PARSE4APP - VERSION 4.4 FOR  G://temp//job2studio4xi//out//one2ftp4app//  WITH PROFILE:  .html  STARTED  09:32:16 02/11/20 FLE Standard Time
# (Step 2A/33) OF MAIN WALK2PARSE4APP - DIRECTORY:  G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app
# (Step 2A/33) OF MAIN WALK2PARSE4APP - DIRECTORY:  G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev
# ===========================================================================
# (Step 3A/33) OF MAIN WALK2PARSE4APP - VERSION 4.4 - IN:  G://temp//job2studio4xi//out//one2ftp4app//  - PROFILE:  .html  COMPLETED   09:32:16 02/11/20 FLE Standard Time
# ===========================================================================
# (Step 4A/33) OF MAIN WALK2PARSE4APP - KB2TAG:  
# kb2tag[  <!doctype html> ]:  {1: 1, 2: 1, 3: None}
# kb2tag[  <a ]:  {1: 1, 2: 9999, 3: '</a>'}
# kb2tag[  <b> ]:  {1: 1, 2: 9999, 3: '</b>'}
# kb2tag[  <body> ]:  {1: 1, 2: 1, 3: '</body>'}
# kb2tag[  <div ]:  {1: 1, 2: 9999, 3: '</div>'}
# kb2tag[  <h3> ]:  {1: 1, 2: 9999, 3: '</h3>'}
# kb2tag[  <head> ]:  {1: 1, 2: 1, 3: '</head>'}
# kb2tag[  <html> ]:  {1: 1, 2: 1, 3: '</html>'}
# kb2tag[  <link ]:  {1: 1, 2: 9999, 3: None}
# kb2tag[  <meta ]:  {1: 1, 2: 1, 3: None}
# kb2tag[  <style ]:  {1: 1, 2: 1, 3: '</style>'}
# kb2tag[  <table> ]:  {1: 1, 2: 1, 3: '</table>'}
# kb2tag[  <tbody> ]:  {1: 1, 2: 1, 3: '</tbody>'}
# kb2tag[  <td> ]:  {1: 1, 2: 9999, 3: '</td>'}
# kb2tag[  <title> ]:  {1: 1, 2: 1, 3: '</title>'}
# kb2tag[  <tr> ]:  {1: 1, 2: 9999, 3: '</tr>'}
# ===========================================================================
# (Step 4B/33) OF MAIN WALK2PARSE4APP - KB2SEARCH:  
# kb2search[  1 ]:  <!doctype html>
# kb2search[  2 ]:  <html>
# kb2search[  3 ]:  <body>
# kb2search[  4 ]:  <table>
# kb2search[  5 ]:  <head>
# kb2search[  6 ]:  <link
# kb2search[  7 ]:  <meta
# kb2search[  8 ]:  <title>
# kb2search[  9 ]:  <style
# kb2search[  10 ]:  <tbody>
# kb2search[  11 ]:  <tr>
# kb2search[  12 ]:  <td>
# kb2search[  13 ]:  <a
# kb2search[  14 ]:  <div
# kb2search[  15 ]:  </html>
# kb2search[  16 ]:  </body>
# kb2search[  17 ]:  </table>
# kb2search[  18 ]:  </head>
# kb2search[  19 ]:  </title>
# kb2search[  20 ]:  </style>
# kb2search[  21 ]:  </tbody>
# kb2search[  22 ]:  </tr>
# kb2search[  23 ]:  </td>
# kb2search[  24 ]:  </a>
# kb2search[  25 ]:  </div>
# kb2search[  26 ]:  <h3>
# kb2search[  27 ]:  <b>
# kb2search[  28 ]:  </h3>
# kb2search[  29 ]:  </b>
# ===========================================================================
# (Step 4C/33) OF MAIN WALK2PARSE4APP - FILES PROCESSED:  
# kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
# kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
# ===========================================================================
# (Step 4D/33) OF MAIN WALK2PARSE4APP - KB2STAT FOR EACH FILE:  
# ===========================================================================
# kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
# kb2statistics[ <style ]:  1
# kb2statistics[ <title> ]:  1
# kb2statistics[ </head> ]:  1
# kb2statistics[ </tr> ]:  245
# kb2statistics[ </html> ]:  1
# kb2statistics[ <link ]:  1
# kb2statistics[ </a> ]:  439
# kb2statistics[ <head> ]:  1
# kb2statistics[ </td> ]:  245
# kb2statistics[ <tbody> ]:  1
# kb2statistics[ <h3> ]:  17
# kb2statistics[ </b> ]:  690
# kb2statistics[ <div ]:  43
# kb2statistics[ <body> ]:  1
# kb2statistics[ <!doctype html> ]:  1
# kb2statistics[ </body> ]:  1
# kb2statistics[ <html> ]:  1
# kb2statistics[ <table> ]:  1
# kb2statistics[ </table> ]:  1
# kb2statistics[ </style> ]:  1
# kb2statistics[ </title> ]:  1
# kb2statistics[ <td> ]:  245
# kb2statistics[ </div> ]:  43
# kb2statistics[ <tr> ]:  245
# kb2statistics[ </tbody> ]:  1
# kb2statistics[ </h3> ]:  17
# kb2statistics[ <a ]:  439
# kb2statistics[ <meta ]:  1
# kb2statistics[ <b> ]:  690
# ===========================================================================
# kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
# kb2statistics[ <style ]:  1
# kb2statistics[ <title> ]:  1
# kb2statistics[ </head> ]:  1
# kb2statistics[ </tr> ]:  245
# kb2statistics[ </html> ]:  1
# kb2statistics[ <link ]:  1
# kb2statistics[ </a> ]:  439
# kb2statistics[ <head> ]:  1
# kb2statistics[ </td> ]:  244
# kb2statistics[ <tbody> ]:  1
# kb2statistics[ <h3> ]:  17
# kb2statistics[ </b> ]:  690
# kb2statistics[ <div ]:  43
# kb2statistics[ <body> ]:  1
# kb2statistics[ <!doctype html> ]:  1
# kb2statistics[ </body> ]:  1
# kb2statistics[ <html> ]:  1
# kb2statistics[ <table> ]:  1
# kb2statistics[ </table> ]:  1
# kb2statistics[ </style> ]:  1
# kb2statistics[ </title> ]:  1
# kb2statistics[ <td> ]:  245
# kb2statistics[ </div> ]:  43
# kb2statistics[ <tr> ]:  245
# kb2statistics[ </tbody> ]:  1
# kb2statistics[ </h3> ]:  17
# kb2statistics[ <a ]:  439
# kb2statistics[ <meta ]:  1
# kb2statistics[ <b> ]:  690
# ===========================================================================
# (Step 4E/33) OF MAIN WALK2PARSE4APP - CHECKED ENOUGH TAGS FOR EACH FILE 
# ===========================================================================
# kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
# kb2statistics[  <style ]: 1  >=  1
# kb2statistics[  <title> ]: 1  >=  1
# kb2statistics[  <link ]: 1  >=  1
# kb2statistics[  <head> ]: 1  >=  1
# kb2statistics[  <tbody> ]: 1  >=  1
# kb2statistics[  <h3> ]: 17  >=  1
# kb2statistics[  <div ]: 43  >=  1
# kb2statistics[  <body> ]: 1  >=  1
# kb2statistics[  <!doctype html> ]: 1  >=  1
# kb2statistics[  <html> ]: 1  >=  1
# kb2statistics[  <table> ]: 1  >=  1
# kb2statistics[  <td> ]: 245  >=  1
# kb2statistics[  <tr> ]: 245  >=  1
# kb2statistics[  <a ]: 439  >=  1
# kb2statistics[  <meta ]: 1  >=  1
# kb2statistics[  <b> ]: 690  >=  1
# ===========================================================================
# kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
# kb2statistics[  <style ]: 1  >=  1
# kb2statistics[  <title> ]: 1  >=  1
# kb2statistics[  <link ]: 1  >=  1
# kb2statistics[  <head> ]: 1  >=  1
# kb2statistics[  <tbody> ]: 1  >=  1
# kb2statistics[  <h3> ]: 17  >=  1
# kb2statistics[  <div ]: 43  >=  1
# kb2statistics[  <body> ]: 1  >=  1
# kb2statistics[  <!doctype html> ]: 1  >=  1
# kb2statistics[  <html> ]: 1  >=  1
# kb2statistics[  <table> ]: 1  >=  1
# kb2statistics[  <td> ]: 245  >=  1
# kb2statistics[  <tr> ]: 245  >=  1
# kb2statistics[  <a ]: 439  >=  1
# kb2statistics[  <meta ]: 1  >=  1
# kb2statistics[  <b> ]: 690  >=  1
# ===========================================================================
# (Step 4F/33) OF MAIN WALK2PARSE4APP - CHECKED THAT NOT EXCEEDED MAXIMUM FOR EACH FILE 
# ===========================================================================
# kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
# kb2statistics[  <style ]: 1  <=  1
# kb2statistics[  <title> ]: 1  <=  1
# kb2statistics[  <link ]: 1  <=  9999
# kb2statistics[  <head> ]: 1  <=  1
# kb2statistics[  <tbody> ]: 1  <=  1
# kb2statistics[  <h3> ]: 17  <=  9999
# kb2statistics[  <div ]: 43  <=  9999
# kb2statistics[  <body> ]: 1  <=  1
# kb2statistics[  <!doctype html> ]: 1  <=  1
# kb2statistics[  <html> ]: 1  <=  1
# kb2statistics[  <table> ]: 1  <=  1
# kb2statistics[  <td> ]: 245  <=  9999
# kb2statistics[  <tr> ]: 245  <=  9999
# kb2statistics[  <a ]: 439  <=  9999
# kb2statistics[  <meta ]: 1  <=  1
# kb2statistics[  <b> ]: 690  <=  9999
# ===========================================================================
# kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
# kb2statistics[  <style ]: 1  <=  1
# kb2statistics[  <title> ]: 1  <=  1
# kb2statistics[  <link ]: 1  <=  9999
# kb2statistics[  <head> ]: 1  <=  1
# kb2statistics[  <tbody> ]: 1  <=  1
# kb2statistics[  <h3> ]: 17  <=  9999
# kb2statistics[  <div ]: 43  <=  9999
# kb2statistics[  <body> ]: 1  <=  1
# kb2statistics[  <!doctype html> ]: 1  <=  1
# kb2statistics[  <html> ]: 1  <=  1
# kb2statistics[  <table> ]: 1  <=  1
# kb2statistics[  <td> ]: 245  <=  9999
# kb2statistics[  <tr> ]: 245  <=  9999
# kb2statistics[  <a ]: 439  <=  9999
# kb2statistics[  <meta ]: 1  <=  1
# kb2statistics[  <b> ]: 690  <=  9999
# ===========================================================================
# (Step 4G/33) OF MAIN WALK2PARSE4APP - CHECKED BALANCE FOR EACH FILE
# ===========================================================================
# (Step 4G1/33) kb2file[  1 ]: G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev\index.html
# ===========================================================================
# (Step 4G1/33) kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
# (Step Z1/33) kb2file[  2 ]: G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html
# (Step Z2/33) ** error kb2statistics[  <td> ]: 245  .NE.  244
# ===========================================================================
# (Step 4H/33) OF MAIN WALK2PARSE4APP - ERROR SUMMARY
# ** kb2file[ 2 ]:  G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app\index.html  ** kb2total[ 2 ]: 1 **
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of walk2parse4app.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

